<?php  //$Id: upgrade.php,v 1.7 2008/07/25 22:06:28 diml Exp $

/**
* This file keeps track of upgrades to 
* the techproject module
*
* Sometimes, changes between versions involve
* alterations to database structures and other
* major things that may break installations.
*
* The commands in here will all be database-neutral,
* using the functions defined in lib/ddllib.php
*
* @package mod-techproject
* @subpackage framework
* @category mod
* @author Valery Fremaux (France) (admin@www.ethnoinformatique.fr)
* @date 2008/03/03
* @version phase1
* @contributors LUU Tao Meng, So Gerard (parts of treelib.php), Guillaume Magnien, Olivier Petit
* @license http://www.gnu.org/copyleft/gpl.html GNU Public License
*/

/**
* The upgrade function in this file will attempt
* to perform all the necessary actions to upgrade
* your older installtion to the current version.
*
* If there's something it cannot do itself, it
* will tell you what you need to do.
*/
function xmldb_techproject_upgrade($oldversion=0) {

    global $CFG, $THEME, $db;

    $result = true;

/// And upgrade begins here. For each one, you'll need one 
/// block of code similar to the next one. Please, delete 
/// this comment lines once this file start handling proper
/// upgrade code.

 if ($result && $oldversion < 2007081100) { //New version in version.php
    $result = $result && modify_database("", "ALTER TABLE `mdl_techproject` DROP `studentscanchangerequs` ; ");
    $result = $result && modify_database("", "ALTER TABLE `mdl_techproject` DROP `studentscanchangespecs` ; ");
    $result = $result && modify_database("", "ALTER TABLE `mdl_techproject` DROP `studentscanchangetasks` ; ");
    $result = $result && modify_database("", "ALTER TABLE `mdl_techproject` DROP `studentscanchangemiles` ; ");
    $result = $result && modify_database("", "ALTER TABLE `mdl_techproject` DROP `studentscanchangedeliv` ; ");
    $result = $result && modify_database("", "ALTER TABLE `mdl_techproject_assessment_criterion` RENAME `mdl_techproject_criterion` ; ");
    $result = $result && modify_database("", "ALTER TABLE `mdl_techproject_deliverable_status` RENAME `mdl_techproject_deliv_status` ; ");
 }

    if ($result && $oldversion < 2008030300) {

    /// Define field xslfilter to be added to techproject
        $table = new XMLDBTable('techproject');
        $field = new XMLDBField('xslfilter');
        $field->setAttributes(XMLDB_TYPE_CHAR, '32', null, null, null, null, null, null, 'enablecvs');

    /// Launch add field xslfilter
        $result = $result && add_field($table, $field);

    /// Define field cssfilter to be added to techproject
        $table = new XMLDBTable('techproject');
        $field = new XMLDBField('cssfilter');
        $field->setAttributes(XMLDB_TYPE_CHAR, '32', null, null, null, null, null, null, 'xslfilter');

    /// Launch add field cssfilter
        $result = $result && add_field($table, $field);
    }

    if ($result && $oldversion < 2008072100) {
    
        /// Define table techproject_collapse to be created
            $table = new XMLDBTable('techproject_collapse');
    
        /// Adding fields to table techproject_collapse
            $table->addFieldInfo('id', XMLDB_TYPE_INTEGER, '10', XMLDB_UNSIGNED, XMLDB_NOTNULL, XMLDB_SEQUENCE, null, null, null);
            $table->addFieldInfo('projectid', XMLDB_TYPE_INTEGER, '11', XMLDB_UNSIGNED, null, null, null, null, null);
            $table->addFieldInfo('entity', XMLDB_TYPE_CHAR, '24', null, null, null, null, null, null);
            $table->addFieldInfo('entryid', XMLDB_TYPE_INTEGER, '11', XMLDB_UNSIGNED, XMLDB_NOTNULL, null, null, null, null);
            $table->addFieldInfo('userid', XMLDB_TYPE_INTEGER, '11', XMLDB_UNSIGNED, XMLDB_NOTNULL, null, null, null, null);
            $table->addFieldInfo('collapsed', XMLDB_TYPE_INTEGER, '1', XMLDB_UNSIGNED, XMLDB_NOTNULL, null, null, null, '1');
    
        /// Adding keys to table techproject_collapse
            $table->addKeyInfo('primary', XMLDB_KEY_PRIMARY, array('id'));
    
        /// Launch create table for techproject_collapse
            $result = $result && create_table($table);
        }

    return $result;
}

?>