<?php

    /**
    * Project : Technical Project Manager (IEEE like)
    *
    * Specification operations.
    *
    * @package mod-techproject
    * @category mod
    * @author Valery Fremaux (France) (admin@www.ethnoinformatique.fr)
    * @date 2008/03/03
    * @version phase1
    * @contributors LUU Tao Meng, So Gerard (parts of treelib.php), Guillaume Magnien, Olivier Petit
    * @license http://www.gnu.org/copyleft/gpl.html GNU Public License
    */

    $usehtmleditor = can_use_html_editor();
    $defaultformat = FORMAT_MOODLE;

/// Controller
    
	if ($work == 'new') {
		$specification->groupid = $currentGroupId;
		$specification->projectid = $project->id;
		$specification->abstract = required_param('abstract', PARAM_TEXT);
		$specification->description = addslashes(required_param('description', PARAM_CLEANHTML));
        $specification->format = required_param('format', PARAM_INT);
		$specification->severity = required_param('severity', PARAM_CLEAN);
		$specification->priority = required_param('priority', PARAM_CLEAN);
		$specification->complexity = required_param('complexity', PARAM_CLEAN);
		$specification->fatherid = required_param('fatherid', PARAM_CLEAN);
		$specification->userid = $USER->id;
		$specification->created = time();
		$specification->modified = time();
		$specification->lastuserid = $USER->id;

        if (!empty($specification->abstract)){
        	$specification->ordering = techproject_tree_get_max_ordering($project->id, $currentGroupId, 'techproject_specification', true, $specification->fatherid) + 1;
    		$returnid = insert_record('techproject_specification', $specification);
            add_to_log($course->id, 'techproject', 'changespecification', "view.php?id=$cm->id&view=specifications&group={$currentGroupId}", 'add', $cm->id);
        }
	}
	elseif ($work == 'doupdate') {
		$specification->id = required_param('specid', PARAM_INT);
		$specification->abstract = required_param('abstract', PARAM_TEXT);
		$specification->description = addslashes(required_param('description', PARAM_CLEANHTML));
        $specification->format = required_param('format', PARAM_INT);
		$specification->severity = required_param('severity', PARAM_CLEAN);
		$specification->priority = required_param('priority', PARAM_CLEAN);
		$specification->complexity = required_param('complexity', PARAM_CLEAN);
		$specification->modified = time();
		$specification->lastuserid = $USER->id;

        if (!empty($specification->abstract)){
    		$res = update_record('techproject_specification', $specification);
            add_to_log($course->id, 'techproject', 'changespecification', "view.php?id=$cm->id&view=specifications&group={$currentGroupId}", 'update', $cm->id);
    		
    		// storing mapping spec to req
    		$spectoreq = optional_param('spectoreq', null, PARAM_INT);
    		if (count($spectoreq) > 0){
    		    // removes previous mapping
    		    delete_records('techproject_spec_to_req', 'projectId', $project->id, 'groupId', $currentGroupId, 'specId', $specification->id);
    
    		    // stores new mapping
        		foreach($spectoreq as $aRequ){
        		    $amap->id = 0;
        		    $amap->projectId = $project->id;
        		    $amap->groupId = $currentGroupId;
        		    $amap->reqId = $aRequ;
        		    $amap->specId = $specification->id;
        		    $res = insert_record('techproject_spec_to_req', $amap);
        		}
        	}
        }
	}
	elseif ($work == 'dodelete') {
		$specid = required_param('specid', PARAM_INT);
		techproject_tree_delete($specid, 'techproject_specification');

        // delete related records
		delete_records('techproject_spec_to_req', 'specId', $specid);
        add_to_log($course->id, 'techproject', 'changespecification', "view.php?id=$cm->id&amp;view=specifications&amp;group={$currentGroupId}", 'delete', $cm->id);
	}
	elseif ($work == 'domove' || $work == 'docopy') {
		$ids = required_param('ids', PARAM_INT);
		$to = required_param('to', PARAM_ALPHA);
		switch($to){
		    case 'requs' : { $table2 = 'techproject_requirement'; $redir = 'requirement'; } break;
		    case 'specs' : { $table2 = 'techproject_specification'; $redir = 'specification'; } break;
		    case 'tasks' : { $table2 = 'techproject_task'; $redir = 'task'; } break;
		    case 'deliv' : { $table2 = 'techproject_deliverable'; $redir = 'deliverable'; } break;
		}
		techproject_tree_copy_set($ids, 'techproject_specification', $table2);
        add_to_log($course->id, 'techproject', "change{$redir}", "view.php?id={$cm->id}&amp;view={$redir}s&amp;group={$currentGroupId}", 'copy/move', $cm->id);
		if ($work == 'domove'){
		    // bounce to deleteitems
		    $work = 'dodeleteitems';
		    $withredirect = 1;
		}
		else{
		    redirect("{$CFG->wwwroot}/mod/techproject/view.php?id={$cm->id}&amp;view={$redir}s", get_string('redirectingtoview', 'techproject') . ' : ' . get_string($redir, 'techproject'));
	    }
	}
	if ($work == 'dodeleteitems') {
		$ids = required_param('ids', PARAM_INT);
		foreach($ids as $anItem){
    	    // save record for further cleanups and propagation
    	    $oldRecord = get_record('techproject_specification', 'id', $anItem);
		    $childs = get_records('techproject_specification', 'fatherid', $anItem);
		    
		    // update fatherid in childs 
		    $query = "
		        UPDATE
		            {$CFG->prefix}techproject_specification
		        SET
		            fatherid = $oldRecord->fatherid
		        WHERE
		            fatherid = $anItem
		    ";
		    execute_sql($query);

    		delete_records('techproject_specification', 'id', $anItem);
    
            // delete all related records
    		delete_records('techproject_spec_to_req', 'projectId', $project->id, 'groupId', $currentGroupId, 'specId', $anItem);
    		delete_records('techproject_task_to_spec', 'projectId', $project->id, 'groupId', $currentGroupId, 'specId', $anItem);
    	}
        add_to_log($course->id, 'techproject', 'changespecification', "view.php?id={$cm->id}&amp;view=specifications&amp;group={$currentGroupId}", 'deleteItems', $cm->id);
    	if (isset($withredirect) && $withredirect){
		    redirect("{$CFG->wwwroot}/mod/techproject/view.php?id={$cm->id}&amp;view={$redir}s", get_string('redirectingtoview', 'techproject') . ' : ' . get_string($redir, 'techproject'));
		}
	}
	elseif ($work == 'doclearall') {
        // delete all records. POWERFUL AND DANGEROUS COMMAND.
		delete_records('techproject_specification', 'projectId', $project->id);
		delete_records('techproject_task_to_spec', 'projectId', $project->id);
		delete_records('techproject_spec_to_req', 'projectId', $project->id);
        add_to_log($course->id, 'techproject', 'changespecification', "view.php?id={$cm->id}&amp;view=specifications&amp;group={$currentGroupId}", 'clear', $cm->id);
	}
	elseif ($work == 'doexport') {
	    $ids = required_param('ids', PARAM_INT);
	    $idlist = implode("','", $ids);
	    $select = "
	       id IN ('$idlist')
	    ";
	    $specifications = get_records_select('techproject_specification', $select);
	    $priorities = get_records('techproject_priority', 'projectid', $project->id);
	    if (empty($priorities)){
	        $priorities = get_records('techproject_priority', 'projectid', 0);
	    }
	    $severities = get_records('techproject_severity', 'projectid', $project->id);
	    if (empty($severities)){
	        $severities = get_records('techproject_severity', 'projectid', 0);
	    }
	    $complexities = get_records('techproject_complexity', 'projectid', $project->id);
	    if (empty($complexities)){
	        $complexities = get_records('techproject_complexity', 'projectid', 0);
	    }
	    include "xmllib.php";
	    $xmlpriorities = recordstoxml($priorities, 'priority_option', '', false, 'techproject');
	    $xmlseverities = recordstoxml($severities, 'severity_option', '', false, 'techproject');
	    $xmlcomplexities = recordstoxml($complexities, 'complexity_option', '', false, 'techproject');
	    $xml = recordstoxml($specifications, 'specification', $xmlpriorities.$xmlseverities.$xmlcomplexities, true, null);
	    $escaped = str_replace('<', '&lt;', $xml);
	    $escaped = str_replace('>', '&gt;', $escaped);
	    print_heading(get_string('xmlexport', 'techproject'));
	    print_simple_box("<pre>$escaped</pre>");
        add_to_log($course->id, 'techproject', 'readspecification', "view.php?id={$cm->id}&amp;view=specifications&amp;group={$currentGroupId}", 'export', $cm->id);
        print_continue("view.php?view=specifications&amp;id=$cm->id");
        return;
	}
	elseif ($work == 'up') {
		$specid = required_param('specid', PARAM_INT);
		techproject_tree_up($project, $currentGroupId,$specid, 'techproject_specification');
	}
	elseif ($work == 'down') {
		$specid = required_param('specid', PARAM_INT);
		techproject_tree_down($project, $currentGroupId,$specid, 'techproject_specification');
	}
	elseif ($work == 'left') {
		$specid = required_param('specid', PARAM_INT);
		techproject_tree_left($project, $currentGroupId,$specid, 'techproject_specification');
	}
	elseif ($work == 'right') {
		$specid = required_param('specid', PARAM_INT);
		techproject_tree_right($project, $currentGroupId,$specid, 'techproject_specification');
	}

/// Add specification form *********************************************************

	if ($work == 'add'){
	    $fatherid = required_param('fatherid', PARAM_INT);
	    $spectitle = ($fatherid) ? 'addsubspec' : 'addspec';
?>
<center>
<?php print_heading(get_string($spectitle, 'techproject'), 'center'); ?>
<script type="text/javascript">
//<![CDATA[
function senddata(){
    document.forms['addspecform'].work.value='new';
    <?php if ($usehtmleditor) echo "document.forms['addspecform'].onsubmit();\n"; ?>
    document.forms['addspecform'].submit();
}

function cancel(){
    <?php if ($usehtmleditor) echo "document.forms['addspecform'].onsubmit();\n"; ?>
    document.forms['addspecform'].submit();
}
//]]>
</script>
<form name="addspecform" method="post" action="view.php#spe<?php p($fatherid) ?>">
<input type="hidden" name="id" value="<?php p($cm->id) ?>" />
<input type="hidden" name="work" value="" />
<input type="hidden" name="fatherid" value="<?php echo $fatherid; ?>" />
<table>
<tr valign="top">
	<td align="right"><b><?php print_string('spectitle', 'techproject') ?>:</b></td>
    <td>
        <input type="text" name="abstract" size="100%" value="" alt="<?php print_string('spectitle', 'techproject') ?>" />
    </td>
</tr>
<tr valign="top">
	<td align="right"><b><?php print_string('severity', 'techproject') ?>:</b>
	</td>
    <td align="left">
<?php
        $severities = techproject_get_options('techproject_severity', $project->id);
        $severityoptions = array();
        foreach($severities as $aSeverity){
            $severityoptions[$aSeverity->severity] = '['. $aSeverity->severity . '] ' . $aSeverity->label;
        }
        choose_from_menu ($severityoptions, 'severity');
        helpbutton('severity', get_string('severity', 'techproject'), 'techproject', true, false);
?>
    </td>
</tr>
<tr valign="top">
	<td align="right"><b><?php print_string('priority', 'techproject') ?>:</b>
	</td>
    <td align="left">
<?php
        $priorities = techproject_get_options('techproject_priority', $project->id);
        $priorityoptions = array();
        foreach($priorities as $aPriority){
            $priorityoptions[$aPriority->priority] = '['. $aPriority->priority . '] ' . $aPriority->label;
        }
        choose_from_menu ($priorityoptions, 'priority');
        helpbutton('priority', get_string('priority', 'techproject'), 'techproject', true, false);
?>
    </td>
</tr>
<tr valign="top">
	<td align="right"><b><?php print_string('complexity', 'techproject') ?>:</b>
	</td>
    <td align="left">
<?php
        $complexities = techproject_get_options('techproject_complexity', $project->id);
        $complexityoptions = array();
        foreach($complexities as $aComplexity){
            $complexityoptions[$aComplexity->complexity] = '['. $aComplexity->complexity . '] ' . $aComplexity->label;
        }
        choose_from_menu ($complexityoptions, 'complexity');
        helpbutton('complexity', get_string('complexity', 'techproject'), 'techproject', true, false);
?>
    </td>
</tr>
<tr valign="top">
    <td align="right"><b><?php  print_string('description', 'techproject') ?>:</b><br />
    <font size="1">
     <?php
        helpbutton('writing', get_string('helpwriting'), 'moodle', true, true);
        echo "<br />";
        if ($usehtmleditor) {
           helpbutton("richtext", get_string('helprichtext'), 'moodle', true, true);
        } else {
           helpbutton('text', get_string('helptext'), 'moodle', true, true);
           echo "<br />";
           emoticonhelpbutton('addspecform', 'description', 'moodle', true, true);
           echo "<br />";
        }
      ?>
      <br />
    </font>
    </td>
    <td>
    <?php
       print_textarea($usehtmleditor, 20, 60, 595, 400, 'description', '');

       if ($usehtmleditor) {
           echo '<input type="hidden" name="format" value="'.FORMAT_HTML.'" />';
           $nohtmleditorneeded = false;
       } else {
           echo '<p align="right">';
           helpbutton('textformat', get_string('formattexttype'));
           print_string('formattexttype');
           echo ':&nbsp;';
           choose_from_menu(format_text_menu(), 'format', $defaultformat, '');
           echo '</p>';
       }
    ?>
    </td>
</tr>
</table>
<input type="button" name="go_btn" value="<?php print_string('savechanges') ?>" onclick="senddata()" />
<input type="button" name="cancel_btn" value="<?php print_string('cancel') ?>" onclick="cancel()" />
</form>
</center>

<?php
	}

/// Update specification form *********************************************************

	elseif ($work == 'update') {
	    $specid = required_param('specid', PARAM_INT);

		if(! $specification = get_record('techproject_specification', 'id', $specid)){
			print_string('errorspecification','techproject');
		}
		else {
?>

<center>
<?php print_heading(get_string('updatespec','techproject'), 'center'); ?>
<script type="text/javascript">
//<![CDATA[
function senddata(){
    document.forms['updatespecform'].work.value='doupdate';
    <?php if ($usehtmleditor) echo "document.forms['updatespecform'].onsubmit();\n"; ?>
    document.forms['updatespecform'].submit();
}

function cancel(){
    <?php if ($usehtmleditor) echo "document.forms['updatespecform'].onsubmit();\n"; ?>
    document.forms['updatespecform'].submit();
}
//]]>
</script>
<form name="updatespecform" method="post" action="view.php#spe<?php p($specification->fatherid) ?>">
<input type="hidden" name="id" value="<?php p($cm->id) ?>" />
<input type="hidden" name="fatherid" value="<?php p($specification->fatherid) ?>" />
<input type="hidden" name="work" value="" />
<input type="hidden" name="specid" value="<?php p($specid) ?>" />
<table>
<tr valign="top">
	<td align="right"><b><?php print_string('spectitle', 'techproject') ?>:</b></td>
    <td align="left">
        <input type="text" name="abstract" size="100%" value="<?php p($specification->abstract) ?>" alt="<?php  print_string('spectitle', 'techproject') ?>" />
    </td>
</tr>
<tr valign="top">
	<td align="right"><b><?php print_string('severity', 'techproject') ?>:</b>
	</td>
    <td align="left">
<?php
        $severities = techproject_get_options('techproject_severity', $project->id);
        $severityoptions = array();
        foreach($severities as $aSeverity){
            $severityoptions[$aSeverity->severity] = '['. $aSeverity->severity . '] ' . $aSeverity->label;
        }
        choose_from_menu ($severityoptions, 'severity', $specification->severity);
        helpbutton('severity', get_string('severity', 'techproject'), 'techproject', true, false);
?>
    </td>
</tr>
<tr valign="top">
	<td align="right"><b><?php print_string('priority', 'techproject') ?>:</b>
	</td>
    <td align="left">
<?php
        $priorities = techproject_get_options('techproject_priority', $project->id);
        $priorityoptions = array();
        foreach($priorities as $aPriority){
            $priorityoptions[$aPriority->priority] = '['. $aPriority->priority . '] ' . $aPriority->label;
        }
        choose_from_menu ($priorityoptions, 'priority', $specification->priority);
        helpbutton('priority', get_string('priority', 'techproject'), 'techproject', true, false);
?>
    </td>
</tr>
<tr valign="top">
	<td align="right">
	    <b><?php print_string('complexity', 'techproject') ?>:</b>
	</td>
    <td align="left">
<?php
        $complexities = techproject_get_options('techproject_complexity', $project->id);
        $complexityoptions = array();
        foreach($complexities as $aComplexity){
            $complexityoptions[$aComplexity->complexity] = '['. $aComplexity->complexity . '] ' . $aComplexity->label;
        }
        choose_from_menu ($complexityoptions, 'complexity', $specification->complexity);
        helpbutton('complexity', get_string('complexity', 'techproject'), 'techproject', true, false);
?>
    </td>
</tr>
<tr valign="top">
    <td align="right"><b><?php print_string('description', 'techproject') ?>:</b><br />
    <font size="1">
     <?php
        helpbutton('writing', get_string("helpwriting"), 'moodle', true, true);
        echo "<br />";
        if ($usehtmleditor) {
           helpbutton('richtext', get_string('helprichtext'), 'moodle', true, true);
        } else {
           helpbutton('text', get_string('helptext'), 'moodle', true, true);
           echo "<br />";
           emoticonhelpbutton('updatespecform', 'description', 'moodle', true, true);
           echo "<br />";
        }
      ?>
      <br />
    </font>
    </td>
    <td>
    <?php
       print_textarea($usehtmleditor, 20, 60, 595, 400, "description", $specification->description);

       if ($usehtmleditor) {
           echo '<input type="hidden" name="format" value="'.FORMAT_HTML.'" />';
           $nohtmleditorneeded = false;
       } else {
           echo '<p align="right">';
           helpbutton('textformat', get_string('formattexttype'));
           print_string('formattexttype');
           echo ':&nbsp;';
           if (empty($specification->format)) {
               $specification->format = $defaultformat;
           }
           choose_from_menu(format_text_menu(), 'format', $specification->format, '');
           echo '</p>';
       }
    ?>
    </td>
</tr>
<tr valign="top">
	<td align="right"><b><?php print_string('spectoreq', 'techproject') ?>:</b>
	</td>
    <td align="left">
        <select name="spectoreq[]" multiple="multiple" size="10">
<?php
        $requirements = techproject_get_tree_options('techproject_requirement', $project->id, $currentGroupId);
        $selection = get_records_select_menu('techproject_spec_to_req', "specId = $specid", '', 'reqId,specId');
        if (!empty($requirements)){
            foreach($requirements as $aRequirement){
                $aRequirement->abstract = format_string($aRequirement->abstract);
                $selected = "";
                if ($selection)
                    $selected = (in_array($aRequirement->id, array_keys($selection))) ? "selected=\"selected\"" : '' ;
                echo "<option value=\"{$aRequirement->id}\" {$selected}>{$aRequirement->ordering} - ".shorten_text($aRequirement->abstract, 90)."</option>";
            }
        }
?>
        </select>
        <?php helpbutton('specificationtorequirement', get_string('spectoreq', 'techproject'), 'techproject', true, false); ?>
    </td>
</tr>
</table>
<input type="button" name="go_btn" value="<?php print_string('savechanges') ?>" onclick="senddata()" />
<input type="button" name="cancel_btn" value="<?php print_string('cancel') ?>" onclick="cancel()" />
</form>
</center>

<?php
		}
	}

/// Delete specification form *********************************************************

	elseif ($work == 'delete') {
	    $specid = required_param('specid', PARAM_INT);
?>

<center>
<?php print_heading(get_string('delete'), 'center'); ?>
<script type="text/javascript">
//<![CDATA[
function senddata(){
    document.forms['deletespecform'].work.value='dodelete';
    document.forms['deletespecform'].submit();
}

function cancel(){
    document.forms['deletespecform'].submit();
}
//]]>
</script>
<form name="deletespecform" method="post" action="view.php">
<input type="hidden" name="id" value="<?php p($cm->id) ?>" />
<input type="hidden" name="specid" value="<?php p($specid) ?>" />
<input type="hidden" name="work" value="" />
<input type="button" name="go_btn" value="<?php print_string('delete') ?>" onclick="senddata()" />
<input type="button" name="cancel_btn" value="<?php print_string('cancel') ?>" onclick="cancel()" />
</form>
</center>

<?php
	}

/// Group operation form *********************************************************

	elseif ($work == "groupcmd") {
	    $ids = required_param('ids', PARAM_INT);
	    $cmd = required_param('cmd', PARAM_ALPHA);
?>

<center>
<?php print_heading(get_string('groupoperations', 'techproject'), 'center'); ?>
<?php print_heading(get_string("group$cmd", 'techproject'), 'center', 'h3'); ?>
<script type="text/javascript">
//<![CDATA[
function senddata(cmd){
    document.forms['groupopform'].work.value="do" + cmd;
    document.forms['groupopform'].submit();
}

function cancel(){
    document.forms['groupopform'].submit();
}
//]]>
</script>
<form name="groupopform" method="get" action="view.php">
<input type="hidden" name="id" value="<?php p($cm->id) ?>" />
<input type="hidden" name="work" value="" />
<?php
        foreach($ids as $anId){
            echo "<input type=\"hidden\" name=\"ids[]\" value=\"{$anId}\" />\n";
        }
        if (($cmd == 'move')||($cmd == 'copy')){
            echo get_string('to', 'techproject');
            $options['requs'] = get_string('requirements', 'techproject');
            $options['tasks'] = get_string('tasks', 'techproject');
            $options['deliv'] = get_string('deliverables', 'techproject');
            choose_from_menu($options, 'to', '', 'choose');
        }
?>
<input type="button" name="go_btn" value="<?php print_string('continue') ?>" onclick="senddata('<?php p($cmd) ?>')" />
<input type="button" name="cancel_btn" value="<?php print_string('cancel') ?>" onclick="cancel()" />
</form>
</center>

<?php
	}
	else {
	    require_js('yui_connection');
?>
<script type="text/javascript">
//<![CDATA[
function sendgroupdata(){
    document.forms['groupopform'].submit();
}
//]]>
</script>
<form name="groupopform" method="post" action="view.php">
<input type="hidden" name="id" value="<?php p($cm->id) ?>" />
<input type="hidden" name="work" value="groupcmd" />
<?php
        if ($USER->editmode == 'on' && has_capability('mod/techproject:changespecs', $context)) {
    		echo "<br/><a href='view.php?id={$cm->id}&amp;work=add&amp;fatherid=0'>".get_string('addspec','techproject')."</a>&nbsp; ";
    	}
		techproject_print_specification($project, $currentGroupId, 0, $cm->id);
        if ($USER->editmode == 'on' && has_capability('mod/techproject:changespecs', $context)) {
    		echo "<br/><a href='view.php?id={$cm->id}&amp;work=add&amp;fatherid=0'>".get_string('addspec','techproject')."</a>&nbsp; ";
    		techproject_print_group_commands();
    	}
?>
</form>
<?php
	}
?>